diff --git a/elf/tst-align3.c b/elf/tst-align3.c
index ac86d623a6..87a8ff81a0 100644
--- a/elf/tst-align3.c
+++ b/elf/tst-align3.c
@@ -17,11 +17,9 @@
    <https://www.gnu.org/licenses/>.  */
 
 #include <support/check.h>
+#include <tst-file-align.h>
 #include <tst-stack-align.h>
 
-/* This should cover all possible page sizes we currently support.  */
-#define ALIGN 0x200000
-
 int bar __attribute__ ((aligned (ALIGN))) = 1;
 
 extern int do_load_test (void);
diff --git a/elf/tst-alignmod3.c b/elf/tst-alignmod3.c
index 0d33f2379d..9520c35220 100644
--- a/elf/tst-alignmod3.c
+++ b/elf/tst-alignmod3.c
@@ -17,11 +17,9 @@
    <https://www.gnu.org/licenses/>.  */
 
 #include <support/check.h>
+#include <tst-file-align.h>
 #include <tst-stack-align.h>
 
-/* This should cover all possible page sizes we currently support.  */
-#define ALIGN 0x200000
-
 int foo __attribute__ ((aligned (ALIGN))) = 1;
 
 void
diff --git a/sysdeps/alpha/tst-file-align.h b/sysdeps/alpha/tst-file-align.h
new file mode 100644
index 0000000000..8fc3c9405d
--- /dev/null
+++ b/sysdeps/alpha/tst-file-align.h
@@ -0,0 +1,20 @@
+/* Check file alignment.  Alpha version.
+   Copyright (C) 2021 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <https://www.gnu.org/licenses/>.  */
+
+/* This should cover all possible alignments we currently support.  */
+#define ALIGN 0x10000
diff --git a/sysdeps/generic/tst-file-align.h b/sysdeps/generic/tst-file-align.h
new file mode 100644
index 0000000000..6ee6783a2a
--- /dev/null
+++ b/sysdeps/generic/tst-file-align.h
@@ -0,0 +1,20 @@
+/* Check file alignment.  Generic version.
+   Copyright (C) 2021 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <https://www.gnu.org/licenses/>.  */
+
+/* This should cover all possible page sizes we currently support.  */
+#define ALIGN 0x200000
diff --git a/sysdeps/microblaze/tst-file-align.h b/sysdeps/microblaze/tst-file-align.h
new file mode 100644
index 0000000000..43c58b29d7
--- /dev/null
+++ b/sysdeps/microblaze/tst-file-align.h
@@ -0,0 +1,20 @@
+/* Check file alignment.  MicroBlaze version.
+   Copyright (C) 2021 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <https://www.gnu.org/licenses/>.  */
+
+/* This should cover all possible alignments we currently support.  */
+#define ALIGN 0x8000
diff --git a/sysdeps/nios2/tst-file-align.h b/sysdeps/nios2/tst-file-align.h
new file mode 100644
index 0000000000..589a2d5ad8
--- /dev/null
+++ b/sysdeps/nios2/tst-file-align.h
@@ -0,0 +1,20 @@
+/* Check file alignment.  Nios II version.
+   Copyright (C) 2021 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <https://www.gnu.org/licenses/>.  */
+
+/* This should cover all possible alignments we currently support.  */
+#define ALIGN 0x8000